﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private Panel1 As Panel
	Private Panel2 As Panel
	
	Private MQTT As MqttClient
	Private BC As ByteConverter
	Private Conectar As Button
	Private Desconectar As Button
	Private Edit1 As String
	
	Private IV1 As B4XView
	Private IV2 As B4XView
	Private IV3 As B4XView
	Private IV4 As B4XView
	Private IV5 As B4XView
	Private IV6 As B4XView
	Private IV7 As B4XView
	Private IV8 As B4XView
	
	Private Start1,Start2,Start3,Start4,Start5,Start6,Start7,Start8 As Boolean
	Private Rel1,Rel2,Rel3,Rel4,Rel5,Rel6,Rel7 As String
	
	Private s_Menu() As String
	Private Url_Text1 As EditText
	Private Port_Text2 As EditText
	Private Nome_Text3 As EditText
	Private Senha_Text4 As EditText
	Private MQTT_Nome,MQTT_Senha,MQTT_Url,MQTT_Port As String
	
	Private Editar As Button
	Private Button1 As Button
	Private Button2 As Button
	Private Button3 As Button
	Private Button4 As Button
	Private Button5 As Button
	Private Button6 As Button
	Private Button7 As Button
	Private Button8 As Button
	Private Label3 As Label
	Private menucount As Int
	
	Private Disp_Text1 As EditText
	Private Disp_Text2 As EditText
	Private Disp_Text3 As EditText
	Private Disp_Text4 As EditText
	Private Disp_Text5 As EditText
	Private Disp_Text6 As EditText
	Private Disp_Text7 As EditText
	Private Disp_Text8 As EditText
	Private Salvar As Button
	Private Temp As String
	Private Label4 As Label
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	
	If File.Exists(File.DirInternal,"MQTT.txt")=False Then   'se o arquivo de texto "mac.txt" contendo o endereço MAC padrão do host não existir
		File.WriteString(File.DirInternal,"MQTT.txt","")	  'a criá-lo, com dados nulos
	End If
	
	If File.Exists(File.DirInternal,"Func.txt")=False Then	  'se o arquivo de texto "mac.txt" contendo o endereço MAC padrão do host não existir
		File.WriteString(File.DirInternal,"Func.txt","")	  'a criá-lo, com dados nulos
	End If
	
	
	Dim cs As CSBuilder
	cs.Initialize.Size(28).BackgroundColor(xui.Color_Yellow).Color(xui.Color_Red).Append("Controle").Pop.Color(xui.Color_Blue) _
        .Append(" Rev.1").Pop.color(xui.Color_Black).Append(" By César").Popall
	B4XPages.SetTitle(Me,cs)
	
	Panel1.Visible=False
	Panel2.Visible=True
	s_Menu = Array As String("Configurar/MQTT","Controle/Dispositivos")
    #if B4A
	For Each sName As String In s_Menu
		B4XPages.AddMenuItem(Me, sName)
	Next
    #End If
	
	Button1.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
	Button1.Gravity = Gravity.CENTER_HORIZONTAL
	Button2.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
	Button2.Gravity = Gravity.CENTER_HORIZONTAL
	Button3.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
	Button3.Gravity = Gravity.CENTER_HORIZONTAL
	Button4.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
	Button4.Gravity = Gravity.CENTER_HORIZONTAL
	Button5.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
	Button5.Gravity = Gravity.CENTER_HORIZONTAL
	Button6.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
	Button6.Gravity = Gravity.CENTER_HORIZONTAL
	Button7.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
	Button7.Gravity = Gravity.CENTER_HORIZONTAL
	Button8.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
	Button8.Gravity = Gravity.CENTER_HORIZONTAL
	MQTTInfo_Ler
	EDITFunc_Ler
End Sub

Sub B4XPage_MenuClick (Tag As String)
	If Tag = "menu" Then 'für iOS Hauptmenü, quasi Sub pg_BarButtonClick (Tag As String)
        #if B4i
        Dim sheet As ActionSheet
        sheet.Initialize("sheet", "", "Cancel", "", s_Menu)
        sheet.Show(Root)
        Wait For sheet_Click (result As String)
        B4XPage_MenuClick(result)
        #End If
	Else
		Dim iIndex As Int = GetIndexInArray(s_Menu, Tag)
		Select iIndex
			Case 0 'Configurar
				Panel1.Visible=True
				Panel2.Visible=False
				'Panel3.Visible=False
			Case 1 'Controle
				Panel2.Visible=True
				Panel1.Visible=False
				'Panel3.Visible=False
				'Case 2 'Controle
				'Panel3.Visible=True
				'Panel1.Visible=False
				'Panel2.Visible=False
		End Select
	End If
End Sub

Sub GetIndexInArray(arr() As String, txt As String) As Int
	Dim iIndex As Int = -1, iCount As Int = 0
	For Each sTxt As String In arr
		If sTxt = txt Then iIndex = iCount
		iCount = iCount + 1
	Next
	Return iIndex
End Sub

Sub  MQTTInfo_Ler
	Dim Load As TextReader
	Load.Initialize(File.OpenInput(File.DirInternal,"MQTT.txt"))
	Url_Text1.Text=Load.ReadLine
	Port_Text2.Text=Load.ReadLine
	Nome_Text3.Text=Load.ReadLine
	Senha_Text4.Text=Load.ReadLine
End Sub
	
Sub EDITFunc_Ler
	Dim Load As TextReader
	Load.Initialize(File.OpenInput(File.DirInternal,"Func.txt"))
	Disp_Text1.Text=Load.ReadLine
	Disp_Text2.Text=Load.ReadLine
	Disp_Text3.Text=Load.ReadLine
	Disp_Text4.Text=Load.ReadLine
	Disp_Text5.Text=Load.ReadLine
	Disp_Text6.Text=Load.ReadLine
	Disp_Text7.Text=Load.ReadLine
	Disp_Text8.Text=Load.ReadLine
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
'Connect to CloudMQTT broker
Sub MQTT_Connect
	MQTT_Nome=Nome_Text3.Text
	MQTT_Senha=Senha_Text4.Text
	MQTT_Url=Url_Text1.Text
	MQTT_Port=Port_Text2.Text
	Dim ClientId As String = Rnd(0, 999999999) 'create a unique id
	MQTT. Initialize("mqtt",MQTT_Url & ":" & MQTT_Port , ClientId)
	Dim ConnOpt As MqttConnectOptions
	ConnOpt.Initialize(MQTT_Nome,MQTT_Senha)
	MQTT.Connect2(ConnOpt)
End Sub

'MQTT CONNECT AND SUBSCRIBE TO TOPIC
Sub MQTT_Connected (Success As Boolean)
	If Success = False Then
		Log(LastException)
		xui.MsgboxAsync("Error de Conexão","")
	Else
		Conectar.Text = "Conectado"
		Conectar.TextColor = xui.Color_Red
		MQTT.Subscribe("Control_Rele8/#", 1)'change the name of the topic!
		MQTT.Subscribe("Rele_1",1)'change the name of the topic!
		MQTT.Subscribe("Rele_2",1)'change the name of the topic!
		MQTT.Subscribe("Rele_3",1)'change the name of the topic!
		MQTT.Subscribe("Rele_4",1)'change the name of the topic!
		MQTT.Subscribe("Rele_5",1)'change the name of the topic!
		MQTT.Subscribe("Rele_6",1)'change the name of the topic!
		MQTT.Subscribe("Rele_7",1)'change the name of the topic!
		MQTT.Subscribe("Rele_8",1)'change the name of the topic!
		MQTT.Subscribe("Temp_Ds",1)'<--- ADD
	End If
End Sub

Private Sub Conectar_Click
	If Conectar.Text = "Conectado" Then
		xui.MsgboxAsync("Você está Conectado!","Casa Controle 1")
	Else
		MQTT_Connect
	End If
End Sub


Sub mqtt_MessageArrived(Topic As String, payload()As Byte)
	If Conectar.Text = "Conectado" Then
	Temp = BytesToString(payload,0,payload.Length,"UTF-8")
		If Topic = "Temp_Ds" Then
			Label4.Text = Temp & " °C"
	End If
	End If
	End Sub
	


Private Sub Desconectar_Click
	If MQTT.IsInitialized Then
		MQTT.Close
	End If
	ExitApplication
End Sub

Private Sub Salvar_Click
	Dim Save As TextWriter
	Save.Initialize(File.OpenOutput(File.DirInternal,"MQTT.txt", False))
	Save.WriteLine(Url_Text1.Text)
	Save.WriteLine(Port_Text2.Text)
	Save.WriteLine(Nome_Text3.Text)
	Save.WriteLine(Senha_Text4.Text)
	Save.Close
	ToastMessageShow("Salvo",True)
End Sub

Private Sub Button1_Click
	If Conectar.Text = "Conectado" Then
		If Rel1 = 0 Then
			Rotate_IV1
			Button1.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
			Button1.Gravity = Gravity.CENTER_HORIZONTAL
			Start1 = True
			MQTT.Publish("Rele_1",BC.StringToBytes(Start1, "utf8"))
			Rel1 = 1
		Else
			Rotate_IV1
			Button1.SetBackgroundImage(LoadBitmap(File.DirAssets, "bton.png"))
			Button1.Gravity = Gravity.CENTER_HORIZONTAL
			Start1 = False
			MQTT.Publish("Rele_1",BC.StringToBytes(Start1, "utf8"))
			Rel1 = 0
		End If
	Else
		xui.MsgboxAsync("Você Não Conectado!","Casa Controle 1")
	End If
	
End Sub

Private Sub Button2_Click
	If Conectar.Text = "Conectado" Then
		If Rel2 = 0 Then
			Rotate_IV2
			Button2.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
			Button2.Gravity = Gravity.CENTER_HORIZONTAL
			Start2 = True
			MQTT.Publish("Rele_2", BC.StringToBytes(Start2, "utf8"))
			Rel2 = 1
		Else
			Rotate_IV2
			Button2.SetBackgroundImage(LoadBitmap(File.DirAssets, "bton.png"))
			Button2.Gravity = Gravity.CENTER_HORIZONTAL
			Start2 = False
			MQTT.Publish("Rele_2", BC.StringToBytes(Start2, "utf8"))
			Rel2 = 0
		End If
	Else
		xui.MsgboxAsync("Você Não Conectado!","Casa Controle 1")
	End If
End Sub

Private Sub Button3_Click
	If Conectar.Text = "Conectado" Then
		If Rel3 = 0 Then
			Rotate_IV3
			Button3.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
			Button3.Gravity = Gravity.CENTER_HORIZONTAL
			Start3 = True
			MQTT.Publish("Rele_3", BC.StringToBytes(Start3, "utf8"))
			Rel3 = 1
		Else
			Rotate_IV3
			Button3.SetBackgroundImage(LoadBitmap(File.DirAssets, "bton.png"))
			Button3.Gravity = Gravity.CENTER_HORIZONTAL
			Start3 = False
			MQTT.Publish("Rele_3", BC.StringToBytes(Start3, "utf8"))
			Rel3 = 0
		End If
	Else
		xui.MsgboxAsync("Você Não Conectado!","Casa Controle 1")
	End If
End Sub

Private Sub Button4_Click
	If Conectar.Text = "Conectado" Then
		If Rel4 = 0 Then
			Rotate_IV4
			Button4.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
			Button4.Gravity = Gravity.CENTER_HORIZONTAL
			Start4 = True
			MQTT.Publish("Rele_4", BC.StringToBytes(Start4, "utf8"))
			Rel4 = 1
		Else
			Rotate_IV4
			Button4.SetBackgroundImage(LoadBitmap(File.DirAssets, "bton.png"))
			Button4.Gravity = Gravity.CENTER_HORIZONTAL
			Start4 = False
			MQTT.Publish("Rele_4", BC.StringToBytes(Start4, "utf8"))
			Rel4 = 0
		End If
	Else
		xui.MsgboxAsync("Você Não Conectado!","Casa Controle 1")
	End If
End Sub

Private Sub Button5_Click
	If Conectar.Text = "Conectado" Then
		If Rel5 = 0 Then
			Rotate_IV5
			Button5.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
			Button5.Gravity = Gravity.CENTER_HORIZONTAL
			Start5 = True
			MQTT.Publish("Rele_5", BC.StringToBytes(Start5, "utf8"))
			Rel5 = 1
		Else
			Rotate_IV5
			Button5.SetBackgroundImage(LoadBitmap(File.DirAssets, "bton.png"))
			Button5.Gravity = Gravity.CENTER_HORIZONTAL
			Start5 = False
			MQTT.Publish("Rele_5", BC.StringToBytes(Start5, "utf8"))
			Rel5 = 0
		End If
	Else
		xui.MsgboxAsync("Você Não Conectado!","Casa Controle 1")
	End If
End Sub

Private Sub Button6_Click
	If Conectar.Text = "Conectado" Then
		If Rel6 = 0 Then
			Rotate_IV6
			Button6.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
			Button6.Gravity = Gravity.CENTER_HORIZONTAL
			Start6 = True
			MQTT.Publish("Rele_6", BC.StringToBytes(Start6, "utf8"))
			Rel6 = 1
		Else
			Rotate_IV6
			Button6.SetBackgroundImage(LoadBitmap(File.DirAssets, "bton.png"))
			Button6.Gravity = Gravity.CENTER_HORIZONTAL
			Start6 = False
			MQTT.Publish("Rele_6", BC.StringToBytes(Start6, "utf8"))
			Rel6 = 0
		End If
	Else
		xui.MsgboxAsync("Você Não Conectado!","Casa Controle 1")
	End If
End Sub

Private Sub Button7_Click
	If Conectar.Text = "Conectado" Then
		If Rel7 = 0 Then
			Rotate_IV7
			Button7.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
			Button7.Gravity = Gravity.CENTER_HORIZONTAL
			Start7 = True
			MQTT.Publish("Rele_7", BC.StringToBytes(Start7, "utf8"))
			Rel7 = 1
		Else
			Rotate_IV7
			Button7.SetBackgroundImage(LoadBitmap(File.DirAssets, "bton.png"))
			Button7.Gravity = Gravity.CENTER_HORIZONTAL
			Start7 = False
			MQTT.Publish("Rele_7", BC.StringToBytes(Start7, "utf8"))
			Rel7 = 0
		End If
	Else
		xui.MsgboxAsync("Você Não Conectado!","Casa Controle 1")
	End If
End Sub

Private Sub Button8_Click
	If Conectar.Text = "Conectado" Then
		Select Case Label3.text
			Case "OFF"
				Rotate_IV8
				Button8.SetBackgroundImage(LoadBitmap(File.DirAssets, "bton.png"))
				Button8.Gravity = Gravity.CENTER_HORIZONTAL
				Label3.Text = "ON"
				Start8 = True
				MQTT.Publish("Rele_8", BC.StringToBytes(Start8, "utf8"))
				Sleep(1000)
				Rotate_IV8
				Button8.SetBackgroundImage(LoadBitmap(File.DirAssets, "btoff.png"))
				Button8.Gravity = Gravity.CENTER_HORIZONTAL
				Label3.Text = "OFF"
		End Select
	Else
		xui.MsgboxAsync("Você Não Conectado!","Casa Controle 1")
	End If
End Sub

'Rotate IV1
Private Sub Rotate_IV1
	IV1.Visible = True
	For i = 1 To 180 Step 5
		IV1.Rotation = (i)
		Sleep(0)
	Next
	IV1.Visible = False
End Sub

Private Sub Rotate_IV2
	IV2.Visible = True
	For i = 1 To 180 Step 5
		IV2.Rotation = (i)
		Sleep(0)
	Next
	IV2.Visible = False
End Sub

Private Sub Rotate_IV3
	IV3.Visible = True
	For i = 1 To 180 Step 5
		IV3.Rotation = (i)
		Sleep(0)
	Next
	IV3.Visible = False
End Sub


Private Sub Rotate_IV4
	IV4.Visible = True
	For i = 1 To 180 Step 5
		IV4.Rotation = (i)
		Sleep(0)
	Next
	IV4.Visible = False
End Sub

Private Sub Rotate_IV5
	IV5.Visible = True
	For i = 1 To 180 Step 5
		IV5.Rotation = (i)
		Sleep(0)
	Next
	IV5.Visible = False
End Sub

Private Sub Rotate_IV6
	IV6.Visible = True
	For i = 1 To 180 Step 5
		IV6.Rotation = (i)
		Sleep(0)
	Next
	IV6.Visible = False
End Sub

Private Sub Rotate_IV7
	IV7.Visible = True
	For i = 1 To 180 Step 5
		IV7.Rotation = (i)
		Sleep(0)
	Next
	IV7.Visible = False
End Sub

Private Sub Rotate_IV8
	IV8.Visible = True
	For i = 1 To 180 Step 5
		IV8.Rotation = (i)
		Sleep(0)
	Next
	IV8.Visible = False
End Sub



Private Sub Editar_LongClick
	If Edit1 = 0 Then
		Disp_Text1.Enabled=False
		Disp_Text2.Enabled=False
		Disp_Text3.Enabled=False
		Disp_Text4.Enabled=False
		Disp_Text5.Enabled=False
		Disp_Text6.Enabled=False
		Disp_Text7.Enabled=False
		Disp_Text8.Enabled=False
		Save_Click
		Edit1 = 1
	Else
		ToastMessageShow("Editar",True)
		Disp_Text1.Enabled=True
		Disp_Text2.Enabled=True
		Disp_Text3.Enabled=True
		Disp_Text4.Enabled=True
		Disp_Text5.Enabled=True
		Disp_Text6.Enabled=True
		Disp_Text7.Enabled=True
		Disp_Text8.Enabled=True
		Edit1 = 0
	End If
End Sub

Sub Save_Click
	Dim Save1 As TextWriter
	Save1.Initialize(File.OpenOutput(File.DirInternal,"Func.txt",False))
	Save1.WriteLine(Disp_Text1.Text)
	Save1.WriteLine(Disp_Text2.Text)
	Save1.WriteLine(Disp_Text3.Text)
	Save1.WriteLine(Disp_Text4.Text)
	Save1.WriteLine(Disp_Text5.Text)
	Save1.WriteLine(Disp_Text6.Text)
	Save1.WriteLine(Disp_Text7.Text)
	Save1.WriteLine(Disp_Text8.Text)
	Save1.Close
	ToastMessageShow("Salvo",True)
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	Select Case KeyCode
		Case 4 'BACK KEY
			menucount = menucount + 1
			If menucount = 3 Then
				If MQTT.IsInitialized Then
					MQTT.Close
				End If
				ExitApplication
			End If
	End Select
	Return True
End Sub

